HDU 4288

来源:互联网 发布:java生成随机字母数组 编辑:程序博客网 时间:2024/05/15 15:10
Problem Description
  In mathematics and computer science, an algorithm describes a set of procedures or instructions that define a procedure. The term has become increasing popular since the advent of cheap and reliable computers. Many companies now employ a single coder to write an algorithm that will replace many other employees. An added benefit to the employer is that the coder will also become redundant once their work is done. 1
  You are now the signle coder, and have been assigned a new task writing code, since your boss would like to replace many other employees (and you when you become redundant once your task is complete).
Your code should be able to complete a task to replace these employees who do nothing all day but eating: make the digest sum.
  By saying “digest sum” we study some properties of data. For the sake of simplicity, our data is a set of integers. Your code should give response to following operations:
  1. add x – add the element x to the set;
  2. del x – remove the element x from the set;
  3. sum – find the digest sum of the set. The digest sum should be understood by

  where the set S is written as {a1, a2, ... , ak} satisfying a1 < a2 < a3 < ... < ak 
  Can you complete this task (and be then fired)?
------------------------------------------------------------------------------
1 See http://uncyclopedia.wikia.com/wiki/Algorithm
 

Input
  There’re several test cases.
  In each test case, the first line contains one integer N ( 1 <= N <= 105 ), the number of operations to process.
  Then following is n lines, each one containing one of three operations: “add x” or “del x” or “sum”.
  You may assume that 1 <= x <= 109.
  Please see the sample for detailed format.
  For any “add x” it is guaranteed that x is not currently in the set just before this operation.
  For any “del x” it is guaranteed that x must currently be in the set just before this operation.
  Please process until EOF (End Of File).
 

Output
  For each operation “sum” please print one line containing exactly one integer denoting the digest sum of the current set. Print 0 if the set is empty.
 

Sample Input
9add 1add 2add 3add 4add 5sumadd 6del 3sum6add 1add 3add 5add 7add 9sum
 

Sample Output
345
Hint
C++ maybe run faster than G++ in this problem.


 

思路:这道题很明显是线段树的单点更新区间求和的问题,因为要求的是对5取余为3的所有数的和,我们可以将对5取余的5种情况进行离散化,而且这道题暴力也能过,不过时间几乎是踩线的。

 

先来暴力代码,这是老板大神的做法,真心碉堡了,暴力的精华在于要保持数组的有序性,只是时间比较长





#include <stdio.h>#include <string.h>#include <algorithm>using namespace std;int n;int a[100005],len;char str[10];__int64 sum;int main(){    int i,j,k;    while(~scanf("%d",&n))    {        len = 0;        while(n--)        {            scanf("%s",str);            if(!strcmp(str,"add"))            {                scanf("%d",&k);                for(i = len++; i>0; i--)//保持有序的插入                {                    if(a[i-1]>k)                        a[i] = a[i-1];                    else                        break;                }                a[i] = k;            }            else if(!strcmp(str,"del"))            {                scanf("%d",&k);                for(i = 0; i<len; i++)//找到删除的位置                    if(a[i] == k)                        break;                for(; i<len; i++)//删除后后面的数前移                    a[i] = a[i+1];                len--;            }            else if(!strcmp(str,"sum"))            {                sum = 0;                for(i = 2; i<len; i+=5)//所有队伍取余为3的和加起来                    sum+=a[i];                printf("%I64d\n",sum);            }        }    }    return 0;}

然后是线段树的,时间方面大大减少了


#include<iostream>#include<stdio.h>#include<algorithm>#include<string>using namespace std;int dp[503],sum[503][503],maxs,n,i,j,t1,t2,p,ans;int main(){    while (scanf("%d",&n)!=EOF){          p=0;          memset(dp,0,sizeof(dp));          memset(sum,0,sizeof(sum));          for (i=0;i<n;i++){              scanf("%d%d",&t1,&t2);              if (t1+t2+1<=n){                 p++;                 sum[t1+1][n-t2]++;                 if (sum[t1+1][n-t2]>n-t2-t1) sum[t1+1][n-t2]=n-t2-t1;                 }              }              ans=0;          for (i=1;i<=n;i++){              maxs=0;              dp[i]=dp[i-1];              for (j=0;j<i;j++){                  if (maxs<dp[j]+sum[j+1][i]) maxs=dp[j]+sum[j+1][i];                  if (ans<maxs) ans=maxs;                  }              if (dp[i]<maxs) dp[i]=maxs;              }          printf("%d\n",ans);          }    return 0;}


0 0